!> This module contains legacy scatci subroutines
module Legacy_SCATCI_module
	use precisn
	use const
	public RDNTFO,RDWF,mkpt,SEARCH,CHN2E,WRTEM,PMKORBS,MKORBS,ham_pars_io,MOVEP,RDINT,RDINTS,MOVEW



contains

!*==mkpt.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE mkpt(kpt,nob,nobc,symtyp,notgt,nctgt,mcont,gucont, &
     &                mocsf,nocsf0,mxcsf,ncont,ncont2,ntgsym,ntgt,  &
     &                numtgt,ncitot,nummx,iexpc,icitg,lusme)
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER(longint) :: ICITG, IEXPC, LUSME, MOCSF, MXCSF, NCITOT, NCONT, &
     &           NCONT2, NOCSF0, NTGSYM, NTGT, NUMMX, SYMTYP
      INTEGER(longint), DIMENSION(ntgsym) :: GUCONT, MCONT, NCTGT, NOTGT, NUMTGT
      INTEGER(longint), DIMENSION(nocsf0) :: KPT
      INTEGER(longint), DIMENSION(*) :: NOB, NOBC
      INTENT (IN) GUCONT, ICITG, IEXPC, LUSME, MCONT, NCTGT, NOB, NOBC, &
     &            NOCSF0, NOTGT, NTGSYM, SYMTYP
      INTENT (OUT) KPT
      INTENT (INOUT) MOCSF, MXCSF, NCITOT, NCONT, NCONT2, NTGT, NUMMX, &
     &               NUMTGT
!
! Local variables
!
      INTEGER :: I, IADD, ICSF, ISYM, JCSF, JORB, M, N
!
!*** End of declarations rewritten by SPAG
!
!     MKPT sets up pointers for mapping when expanding energy expresions
!     The pointers are set for MOCSF new CSFs expanded from NOCSF0
!     prototype CSFs generated in CONGEN as follows:
!
!     KPT orbital sequence number for the continuum orbital in this CSF
!
!     Also determine size parameters for CI target contraction
!
!
      mxcsf=nocsf0
      icsf=0
      jcsf=0
      ntgt=0
      ncont2=0
      ncont=0
      DO n=1, ntgsym
         IF(numtgt(n).LT.1)numtgt(n)=1
         nummx=max(nummx,numtgt(n))
         ntgt=ntgt+numtgt(n)
         ncitot=ncitot+nctgt(n)*numtgt(n)
         ncont2=ncont2+notgt(n)*numtgt(n)
         IF(iexpc.EQ.0)THEN
            ncont=ncont+nctgt(n)*notgt(n)
            CYCLE
         END IF
!     extra CSFs for nth target state
         iadd=(notgt(n)-2)
         mxcsf=mxcsf+iadd*nctgt(n)
!     symmetry of nth target state
         IF(symtyp.NE.1)THEN
            isym=mcont(n)+1
         ELSE
            isym=2*mcont(n)+1
            IF(mod(mcont(n),2).EQ.0 .AND. gucont(n).LT.0)isym=isym+1
            IF(mod(mcont(n),2).NE.0 .AND. gucont(n).GT.0)isym=isym+1
         END IF
!     orbital sequence number of first continuum orbital for nth target
         jorb=0
         DO i=1, isym-1
            jorb=jorb+nob(i)
         END DO
         jorb=jorb+nobc(isym)+1
         DO m=1, nctgt(n)
            icsf=icsf+1
            jcsf=jcsf+1
!     first  continuum orbital for each target state:
            kpt(icsf)=jorb
            icsf=icsf+1
            jcsf=jcsf+1
!     second continuum orbital for each target state:
            kpt(icsf)=jorb+1
            jcsf=jcsf+iadd
         END DO
      END DO
      IF(iexpc.NE.0)THEN
!        number of prototype continuum CSF
         ncont=icsf
!        pointers for L**2 CSFs
         DO i=icsf+1, nocsf0
            jcsf=jcsf+1
            kpt(i)=0
         END DO
      END IF
      IF(icitg.EQ.0)THEN
!     reset parameters when no CI target contraction requested
         DO n=1, ntgsym
            IF(nctgt(n).NE.1)THEN
               WRITE(stdout,99)
 99            FORMAT(/  &
     &              ' Attempt to do expand prototype CSFs for CI target' &
     &              ,/' Option not implemented: STOP')
               STOP
            END IF
         END DO
      END IF
      mocsf=ncont2+nocsf0-ncont
      IF(LUSME.NE.0)WRITE(lusme,*)mocsf
      RETURN
      END SUBROUTINE MKPT




!*==mkorbs.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE MKORBS(NSYM,MN,MG,MM,MS,NORB,NSRBD,MAP,MPOS,mcon,mcorb, &
     &                  IPOSIT,NOBL,NOB0L,SYMTYP,LUSME)
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER(longint) :: IPOSIT, LUSME, NORB, NSRBD, NSYM, SYMTYP
      INTEGER(longint), DIMENSION(NORB) :: MAP
      INTEGER(longint), DIMENSION(nsrbd) :: MCON
      INTEGER(longint), DIMENSION(*) :: MCORB, MG, MM, MN, MS
      INTEGER(longint), DIMENSION(NSRBD) :: MPOS
      INTEGER(longint), DIMENSION(20) :: NOB0L, NOBL
      INTENT (IN) IPOSIT, LUSME, NOB0L, NOBL, NORB, NSRBD, NSYM, SYMTYP
      INTENT (OUT) MCORB
      INTENT (INOUT) MAP, MCON, MG, MM, MN, MPOS, MS
!
! Local variables
!
      INTEGER, SAVE :: I, IC, ICON, IK, IKP, IPOS, IS, ISO, J, K, M, M1, &
     &                 MA, MB, N, NEP, NSRB
      INTEGER, DIMENSION(20), SAVE :: NOBLJ
!
!*** End of declarations rewritten by SPAG
!
!........................................
      DO is=1, nsym
         NOBLJ(is)=NOBL(is)
      END DO

      IF(IPOSIT.NE.0)THEN
         DO is=1, nsym
            NOBLJ(is)=NOBL(is)/2
         END DO
      END IF

      IF(SYMTYP.EQ.0)THEN
         IC=1
         ISO=4
      ELSE IF(SYMTYP.EQ.1)THEN
         IC=2
         ISO=4
      ELSE
         IC=1
         ISO=2
      END IF
      I=1
      MA=0
      DO J=1, IC
         M1=MA+1
         MA=MA+NOBLJ(J)
         IPOS=0
         DO N=M1, MA
            MAP(N)=N

            IF(n.LT.nob0l(j)+m1)THEN
               icon=1
            ELSE
               icon=0
            END IF
            mcorb(n)=icon
            MN(I)=N
            MG(I)=0
            MM(I)=0
            MS(I)=0
            MPOS(I)=IPOS
            mcon(i)=icon
            I=I+1
            MN(I)=N
            MG(I)=0
            MM(I)=0
            MS(I)=1
            MPOS(I)=IPOS
            mcon(i)=icon
            I=I+1
         END DO
      END DO
      K=MA+1
!
      DO M=IC+1, NSYM*IC
         MA=NOBLJ(M)
         MB=(M-1)/IC
         IPOS=0
         DO N=1, MA
            MAP(K)=K

            IF(n.LE.nob0l(m))THEN
               icon=1
            ELSE
               icon=0
            END IF
            mcorb(k)=icon
            DO J=1, ISO
               MN(I)=K
               MG(I)=0
               MM(I)=MB
               MS(I)=0
               MPOS(I)=IPOS
               mcon(i)=icon
               I=I+1
            END DO
            K=K+1
            MS(I-1)=1
            IF(SYMTYP.LE.1)THEN
               MM(I-1)=-MB
               MM(I-2)=-MB
               MS(I-3)=1
            END IF
         END DO
      END DO
      NSRB=I-1

      IF(IPOSIT.EQ.0)GO TO 955
!
!...................POSITRON LOOP BEGINS.......................
!
      WRITE(stdout,*)' MAP : OLD, NEW'
      IK=K-1
      IKP=IK+1
!     NEP = total number of orbitals (electron + positron)
      NEP=IK+IK
      DO N=IKP, NEP
         MAP(N)=MAP(N-IK)
      END DO
      write(stdout,*)' MAP : OLD, NEW'
      DO N=1, NEP
         write(stdout,*)N, MAP(N)
      END DO
      IF(LUSME.NE.0)THEN
         WRITE(LUSME,*)NEP
         WRITE(LUSME,*)map
      END IF
      DO N=IKP, NEP
         MN(IK+IKP)=N
         IK=IK+1
         MN(IK+IKP)=N
         IK=IK+1
      END DO
      DO J=1, NEP
         MG(J+NEP)=MG(J)
         MM(J+NEP)=MM(J)
         MS(J+NEP)=MS(J)
         MPOS(J+NEP)=1

      END DO
      NSRB=2*NSRB
!
!...................POSITRON LOOP ENDS.......................
!
 955  CONTINUE

      write(stdout,*) '                  I         N         G         M&
     &         S      MPOS      MCON'
      DO J=1, NSRB
         write(stdout,3000)J, MN(J), MG(J), MM(J), MS(J), MPOS(J), MCON(J)
      END DO
 3000 FORMAT(10X,7I10)
      write(stdout,*) 'GIVEN NSRBD=', NSRBD
      write(stdout,*) 'CALCULATED NSRB=', NSRB
      IF(nsrb.NE.nsrbd)THEN
         write(stdout,960)nsrbd, nsrb
 960     FORMAT(' Inconsistency detected in subroutine MKORBS:',  &
     &          /' Given NSRBD =',i5,' calculated NSRB =',i5,' STOP')
         STOP
      END IF
      RETURN
      END SUBROUTINE MKORBS

!*==pmkorbs.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE PMKORBS(nob,nobe,nob0,nsym,mn,mg,mm,ms,mcon,mcorb,NORB,  &
     &                   NSRBD,map,mpos,iposit,symtyp,LUSME)
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: IPOSIT, LUSME, NORB, NSRBD, NSYM, SYMTYP
      INTEGER, DIMENSION(norb) :: MAP, MCORB
      INTEGER, DIMENSION(nsrbd) :: MCON, MG, MM, MN, MS
      INTEGER, DIMENSION(2*nsrbd) :: MPOS
      INTEGER, DIMENSION(nsym) :: NOB, NOB0, NOBE
      INTENT (IN) LUSME, NOB, NOB0, NOBE, NORB, NSRBD, NSYM, SYMTYP
      INTENT (OUT) MCON, MCORB, MG, MM, MN, MPOS, MS
      INTENT (INOUT) MAP
!
! Local variables
!
      INTEGER :: AMO, EMO, ICON, IMO, IPOS, ISO, ISPIN, ISYM, JMO, &
     &           MAXMO, MAXSPIN, MINMO, NSRB
!
!*** End of declarations rewritten by SPAG
!
!     setting up the following arrays:
!       mn() = orbital number
!       mg() = ??? destinguish gerade and ungerade
!       mm() = ??? m-quantum number for degenerate MOs
!       ms() = spin (for alpha=0, for beta=1)
!       mpos() = flag for positron (for e-=0, for p+=1)
!     NOTE: only implemented for poly-atomic code (symtyp=2)

!.........................................
      IF(symtyp.NE.2)THEN
         write(stdout,*)' ERROR in PMKORBS: calculation with positrons'
         write(stdout,*)'                   only possible for SYMTYP=2'
         write(stdout,*)'                   (abelian groups).'
         write(stdout,*)' here: SYMTYP=', SYMTYP
         STOP

      END IF

      maxspin=2

!     imo = mo-number
!     iso = so-number
!     ipos = positron-flag
!          = 0 for 1..nobe(isym)
!          = 1 for nobe(isym)..nob(isym)

      imo=0
      iso=0
      emo=0
      DO isym=1, nsym

!     electronic MOs

         ipos=0
         icon=1
         maxmo=nobe(isym)
         amo=emo
         DO jmo=1, maxmo
            imo=imo+1
            emo=emo+1
            IF(jmo.GT.nob0(isym))THEN
               icon=0
            END IF
            mcorb(imo)=icon
            map(imo)=emo
            DO ispin=1, maxspin
               iso=iso+1
               mn(iso)=imo
               mg(iso)=0
               mm(iso)=isym-1
               ms(iso)=ispin-1
               mpos(iso)=ipos
               mcon(iso)=icon
!            write(stdout,*),iso,imo,mn(iso)
            END DO
         END DO

!     positronic MOs

         ipos=1
         minmo=nobe(isym)+1
         maxmo=nob(isym)
         icon=0
!        shift=ipos*nobe(isym)
         emo=amo
         DO jmo=minmo, maxmo
            imo=imo+1
            emo=emo+1
            mcorb(imo)=icon
!          map(imo)=imo-shift
            map(imo)=emo
            DO ispin=1, maxspin
               iso=iso+1
               mn(iso)=imo
               mg(iso)=0
               mm(iso)=isym-1
               ms(iso)=ispin-1
               mpos(iso)=ipos
               mcon(iso)=icon
            END DO
         END DO

      END DO

      nsrb=iso

      IF(LUSME.NE.0)THEN
         WRITE(LUSME,*)NORB
         WRITE(LUSME,*)MAP
      END IF
!     control number of spin orbitals

      write(stdout,*)'GIVEN NSRBD=', NSRBD
      write(stdout,*)'CALCULATED NSRB=', NSRB

      IF(NSRB.NE.NSRBD)THEN
         write(stdout,1010)NSRB, NSRBD
 1010    FORMAT(' HELP!!! MKORBS: NSRB, NSRBD = ',2I6)
         STOP
      END IF
      RETURN
      END SUBROUTINE PMKORBS


!-----------------------IO functions-----------------------------------!




!> Legacy function taken from scatci_routines.f
!*==rdnfto.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE RDNFTO(megul,nob,nob0,nobl,nob0l,nsym,ndtrf,nelt,nodo, &
     &                  nocsf,iphz,nctarg,nctgt,notgt,mcont,gucont, &
     &                  ntgsym,ntgcon,nobe,nobp,nobv,iposit)
!
!     read CSFs as generated and projected by CONGEN (part 1)
!            NODO(NOCSF) NO OF DTRS IN EACH INPUT WF
!            NDTRF(NELT) REFERENCE DTR IN EXPANDED FORM
!
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: IPOSIT, MEGUL, NCTARG, NELT, NOCSF, NSYM, NTGCON, &
     &           NTGSYM
      INTEGER, DIMENSION(ntgsym) :: GUCONT, MCONT, NCTGT, NOTGT
      INTEGER, DIMENSION(nctarg) :: IPHZ
      INTEGER, DIMENSION(NELT) :: NDTRF
      INTEGER, DIMENSION(NSYM) :: NOB
      INTEGER, DIMENSION(nsym) :: NOB0, NOBE, NOBP, NOBV
      INTEGER, DIMENSION(2*nsym) :: NOB0L, NOBL
      INTEGER, DIMENSION(NOCSF) :: NODO
      INTENT (IN) MEGUL, NCTARG, NELT, NOCSF, NSYM, NTGCON, NTGSYM
      INTENT (OUT) GUCONT, IPHZ, MCONT, NDTRF, NOB, NOB0, NOB0L, NOBE, &
     &             NOBL, NOBP, NOBV, NODO, NOTGT
      INTENT (INOUT) IPOSIT, NCTGT
!
! Local variables
!
      INTEGER :: I, ITG
!
!*** End of declarations rewritten by SPAG
!
      IF(iposit.EQ.0)THEN
         IF(nctarg.GT.0)THEN
            IF(ntgcon.GT.0)READ(megul)iphz, nctgt, notgt, mcont, gucont
            IF(ntgcon.LE.0)READ(megul)iphz
            READ(megul)NOB, NDTRF, NODO, IPOSIT, NOB0, nobl, nob0l
         END IF
      END IF
      IF(iposit.NE.0)THEN
         IF(ntgcon.GT.0)THEN
            READ(megul)iphz
            READ(megul)(nctgt(itg),itg=1,ntgcon)
            READ(megul)(notgt(itg),itg=1,ntgcon)
            READ(megul)(mcont(itg),itg=1,ntgcon)
            READ(megul)(gucont(itg),itg=1,ntgcon)
            WRITE(*,*)'in rdnfto-gt: nctgt=', nctgt
         END IF
         IF(ntgcon.LE.0)THEN
            READ(megul)iphz
            WRITE(*,*)'in rdnfto-le: nctgt=', nctgt
         END IF
         READ(megul)NOB, NDTRF, NODO, IPOSIT, NOB0, nobl, nob0l
         READ(megul)(NOBE(I),I=1,nsym)
         READ(megul)(NOBP(I),I=1,nsym)
         READ(megul)(NOBV(I),I=1,nsym)
      END IF
      RETURN
      END SUBROUTINE RDNFTO


	!> Legacy function taken from scatci_routines.f
!*==rdwf.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE RDWF(M,ICDO,INDO,NDO,LNDOF,CDO,LCDOF,megul)
!
!     read CSFs as generated and projected by CONGEN (part 2)
!            NDO(LNDOF)  DTRS IN PACKED FORM
!            CDO(LCDOF)  CORRESPONDING COEFFICIENTS
!            INDO(NOCSF+1) INDEX ON DTRS
!            ICDO(NOCSF+1) INDEX ON COEF.
!
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER(longint) :: LCDOF, LNDOF, M, MEGUL
      REAL(KIND=wp), DIMENSION(LCDOF) :: CDO
      INTEGER(longint), DIMENSION(M) :: ICDO, INDO
      INTEGER(longint), DIMENSION(LNDOF) :: NDO
      INTENT (IN) LCDOF, LNDOF, M, MEGUL
      INTENT (OUT) CDO, ICDO, INDO, NDO
!
!*** End of declarations rewritten by SPAG
!
      READ(megul)ICDO, INDO
      READ(megul)NDO
      READ(megul)CDO
      RETURN
      END SUBROUTINE RDWF


!*==search.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE SEARCH(IUNIT,A,ifail)
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      CHARACTER(LEN=8) :: A
      INTEGER :: IFAIL, IUNIT
      INTENT (IN) A, IUNIT
      INTENT (OUT) IFAIL
!
! Local variables
!
      CHARACTER(LEN=8) :: A1
      CHARACTER(LEN=8), DIMENSION(4) :: B
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     Utility to search a dataset IUNIT for header A where the dataset
!     is assumed to have MOLECULE-SWEDEN convention headers. The header
!     convention is
!
!     '********', '        ', '        ', 'ABCDEFGH'
!
!     where ABCDEFGH is a character string such as ONEELINT etc.
!
!***********************************************************************
!

      DATA A1/'********'/
!
 1    READ(IUNIT,END=3)B
      IF(B(1).NE.A1 .OR. B(4).NE.A)GO TO 1
!
      ifail=0
      RETURN
!
!---- Process error condition namely, header not found by end of file
!
 3    ifail=1
      RETURN
!
      END SUBROUTINE SEARCH



      SUBROUTINE chn2e(nftin,iwrite,xint2e,nint2e)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      USE params, ONLY : LRECIN=>LRECLX, ctrans2
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: IWRITE, NFTIN, NINT2E
#if (mpithree)
      REAL(KIND=wp), POINTER     :: XINT2E(:)
#else
      REAL(KIND=wp), ALLOCATABLE :: XINT2E(:)
#endif
      INTENT (IN) IWRITE, NINT2E
      INTENT (INOUT) XINT2E
!
! Local variables
!
      INTEGER :: I, ICOUNT, IFAIL, INBOX, LAST
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     Read the two electron part of the file of unformatted transformed
!     integrals from MOLECULE-SWEDEN and copy these to a new format
!     which is Alchemy I compatible.
!
!     Input Data:
!          nftin  logical unit holding MOLECULE-SWEDEN integrals
!         iwrite  logical unit for the printer
!     Output Data:
!         xint2e  array for the integrals
!
!     Notes: Alchemy requires to read integrals in boxes of preset
!            size because that is the way that the formulae are sorted.
!            Sweden on the other hand writes all integrals in one long
!            vector split into equal length records. This routine
!            is a simple interface between the two codes which
!            rearrangesthe Sweden integrals into records which are the
!            same size as an Alchemy box. Thus routine procbs can simpl
!            use a vectorized read of a single vector. It is clearly
!            possible to enhance the speed of this coding at the expense
!            of complicating the do loops.
!
!***********************************************************************
!
!---- Rewind transformed integrals file and start of the two electron
!     integrals
!
      REWIND nftin
!
      CALL search(nftin,ctrans2,ifail)
!
!---- Loop until end of file reading records of length lrecin
!     words each time.
!
!.... Initialize for the loop
      icount=1
      inbox=0
!
!.... Begin a Fortran implementation of a repeat until loop
!     which returns to 300 until end file forces jump to 400
!
      last=min(lrecin,nint2e)
 300  READ(nftin,END=400,ERR=990)(xint2e(inbox+i),i=1,last)
      icount=icount+1
      inbox=inbox+lrecin
      IF(inbox+lrecin.GT.nint2e)last=nint2e-inbox
      GO TO 300
!
!---- End of file condition reached, jump out of the loop
!
 400  WRITE(iwrite,4000)icount-1
 4000 FORMAT(/,10x,'End of file reached. Swed.Record count = ',i10,//)
!
      REWIND nftin
!
      RETURN
!
!---- Abnormal termination on two electron integral reading
!
 990  WRITE(iwrite,9900)icount
 9900 FORMAT(/,10x,'Error on read for 2-e ints. Record = ',i10,//)
      STOP
!
      END SUBROUTINE CHN2E

      SUBROUTINE WRTEM(NFTE,NT,LEMBF,NEMBF,EM)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: LEMBF, NFTE, NT
      REAL(KIND=wp), DIMENSION(LEMBF) :: EM
      INTEGER, DIMENSION(2,LEMBF) :: NEMBF
      INTENT (IN) EM, LEMBF, NEMBF, NFTE, NT
!
!*** End of declarations rewritten by SPAG
!
!**********************************************************************

!     WRTEM WRITES THE ENERGY MATRIX EM TO THE DISK FILE ASSOCIATED
!          WITH UNIT NFTE
!
!**********************************************************************
!
!
      WRITE(NFTE)NT, NEMBF, EM
!
      RETURN
      END SUBROUTINE WRTEM


      SUBROUTINE READCID(nftw,nciset,NAME,NHE,NHD,DTNUC,nocsf,NSTAT, &
     &                   nctgt,EIG,VEC,iphase,NFT)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      CHARACTER(LEN=120) :: NAME
      INTEGER :: NCISET, NCTGT, NFT, NFTW, NOCSF, NSTAT
      REAL(KIND=wp), DIMENSION(41) :: DTNUC
      REAL(KIND=wp), DIMENSION(*) :: EIG, VEC
      INTEGER, DIMENSION(*) :: IPHASE
      INTEGER, DIMENSION(10) :: NHD
      INTEGER, DIMENSION(20) :: NHE
      INTENT (IN) NCTGT
      INTENT (INOUT) NHD, NOCSF
!
! Local variables
!
      INTEGER :: NALM, NT
!
!*** End of declarations rewritten by SPAG
!
!**********************************************************************
!
!    READCID reads CI data from unit NFTW in format used for diatomic
!     targets
!
!**********************************************************************
!
!
      CALL MOVEW(NFTW,nciset,NALM,0,NFT)
      IF(NALM.NE.0)GO TO 2900
!
      READ(NFTW,END=2900)NT, NHD, NAME, NHE, DTNUC
      NOCSF=NHD(2)
      IF(nstat.GT.nhd(3))THEN
         WRITE(nft,2980)nstat, nhd(3)
 2980    FORMAT(/' Target state number',i4,' requested', &
     &          /' Only               ',i4,' on file: STOP')
         STOP
      END IF
!
!     READ CI COEFFICIENTS
!
      CALL CIVIO(NFTW,1,NOCSF,NSTAT,EIG,VEC,NALM,iphase,vec)
      IF(NALM.NE.0)GO TO 2900
      IF(NOCSF.EQ.NCTGT)THEN
         CALL PRTHD(nciset,NHD,NAME,NHE,DTNUC,NSTAT,EIG,NFT)
      ELSE
         WRITE(NFT,2920)NOCSF, NCTGT
 2920    FORMAT(/' HAMILTONIAN TRANSFORMATION DATA INCONSISTENT ',2I10)
         STOP
      END IF
!
      RETURN
!
 2900 WRITE(NFT,2910)
 2910 FORMAT(/' UNABLE TO GET CI-TARGET VECTOR ')
      STOP
      END SUBROUTINE READCID
!*==readcip.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE READCIP(nftw,nciset,nocsf,nstat1,nctgt,mgvn,s,sz,nelt, &
     &                   EIG,VEC,iphase,NFT)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      USE scatci_data, ONLY : MEIG
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: MGVN, NCISET, NCTGT, NELT, NFT, NFTW, NOCSF, NSTAT1
      REAL(KIND=wp) :: S, SZ
      REAL(KIND=wp), DIMENSION(*) :: EIG, VEC
      INTEGER, DIMENSION(*) :: IPHASE
      INTENT (IN) NCTGT, NSTAT1
      INTENT (OUT) MGVN, NELT, S, SZ
      INTENT (INOUT) NOCSF
!
! Local variables
!
      REAL(KIND=wp), ALLOCATABLE, DIMENSION(:) :: CHARGE, XNUC, YNUC, &
     &                                            ZNUC
      CHARACTER(LEN=8), ALLOCATABLE, DIMENSION(:) :: CNAME
      REAL(KIND=wp) :: E0
      INTEGER :: I, NALM, NEIG, NNUC, NREC, NSET, NSTAT
      CHARACTER(LEN=120) :: NAME
!
!*** End of declarations rewritten by SPAG
!
!**********************************************************************
!
!     READCIP reads CI data from unit NFTW in format used for
!     polyatomic targets
!
!**********************************************************************
!
!
!.... Find file
      CALL MOVEP(NFTW,nciset,NALM,0,NFT)
      IF(NALM.NE.0)GO TO 1800
!
      READ(nftw)
      READ(NFTW)Nset, nrec, NAME, nnuc, nocsf, nstat, mgvn, s, sz, nelt, &
     &          e0
      ALLOCATE(xnuc(nnuc),ynuc(nnuc),znuc(nnuc),charge(nnuc), &
     &         CNAME(nnuc))
      DO i=1, nnuc
         READ(nftw)cname(i), xnuc(i), ynuc(i), znuc(i), charge(i)
      END DO
      IF(nset.NE.nciset)GO TO 1800
      IF(nstat1.GT.nstat)THEN
         WRITE(nft,2980)nstat1, nstat
 2980    FORMAT(/' Target state number',i4,' requested', &
     &          /' Only               ',i4,' on file: STOP')
         STOP
      END IF
!
!     READ CI COEFFICIENTS, ZM changed nstat to nstat1 to ensure only
!     the states requested by CIRMAT are read-in.
!
      CALL CIVIO(NFTW,1,NOCSF,nstat1,EIG,VEC,NALM,iphase,vec)
      IF(NALM.NE.0)GO TO 2900
      IF(NOCSF.EQ.NCTGT)THEN
!
!....   Print summary of target data
         WRITE(NFT,100)NSET, name
         WRITE(NFT,101)nocsf, nstat, nnuc
         WRITE(NFT,120)(cname(i),xnuc(i),ynuc(i),znuc(i),charge(i),i=1, &
     &                 nnuc)
         NEIG=MIN(MEIG,nstat1)
         WRITE(NFT,102)(EIG(I)+E0,I=1,NEIG)
      ELSE
!....   Error
         WRITE(NFT,2920)NOCSF, NCTGT
         STOP
      END IF
      DEALLOCATE(xnuc,ynuc,znuc,charge,cname)
      RETURN
!
 1800 WRITE(nft,1804)nftw
 1804 FORMAT(/' CIDATA NOT FOUND ON UNIT',I3)
      STOP
!
 2900 WRITE(NFT,2910)
 2910 FORMAT(/' UNABLE TO GET CI-TARGET VECTOR ')
      STOP
!
 100  FORMAT(' SET',I4,4X,A)
 101  FORMAT(10X,'NOCSF=',I5,4X,'NSTAT=',I5,4X,'NNUC =',I5)
 102  FORMAT(10X,'EIGEN-ENERGIES OF THE REQ. STATES',/(16X,5F20.10))
 120  FORMAT(/' Nuclear data     X         Y         Z       Charge'/ &
     &       (3x,a8,2x,4F10.6))
 2920 FORMAT(/' HAMILTONIAN TRANSFORMATION DATA INCONSISTENT ',2I10)
!
      END SUBROUTINE READCIP



!*==movew.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE MOVEW(NFT,NTH,NALM,NPFLG,NFT1)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      USE scatci_data, ONLY : MEIG
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: NALM, NFT, NFT1, NPFLG, NTH
      INTENT (IN) NFT, NPFLG
      INTENT (OUT) NALM
      INTENT (INOUT) NTH
!
! Local variables
!
      REAL(KIND=wp), DIMENSION(41) :: DTNUC
      REAL(KIND=wp), DIMENSION(MEIG) :: EIG
      INTEGER :: I, IDUM, J, K, M, NEIG, NHDIM, NSET, NSTAT, NT
      CHARACTER(LEN=120) :: NAME
      INTEGER, DIMENSION(10) :: NHD
      INTEGER, DIMENSION(20) :: NHE
      LOGICAL :: OPN
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     MOVEW LOCATES THE NTH-DATASET CONTAINED ON THE ALCHEMY CI
!           DUMPFILE ASSOCIATED WITH UNIT NFT
!
!           NPFLG = 0     NO PRINTOUT DURING SEARCH
!                 = 1     PRINT HEADER LABELS ENCOUNTERED
!           NALM  = 0     NO ERRORS DETECTED
!                 = 1     ERRORS DETECTED
!
!***********************************************************************
!
!
      NALM=0
      INQUIRE(UNIT=nft,OPENED=opn)
      IF(opn)THEN
         REWIND NFT
      ELSE
         OPEN(UNIT=nft,FORM='unformatted')
      END IF
      IF(NTH.EQ.1)RETURN
      M=NTH-1
      IF(NTH.EQ.0)M=2000
      DO I=1, M
         READ(NFT,END=50)NT, NHD, NAME, NHE, DTNUC
         NSET=NT
         NHDIM=NHD(8)
         NSTAT=NHD(3)
         NEIG=MIN(MEIG,NSTAT)
         READ(NFT)(IDUM,J=1,NHDIM), (EIG(J),J=1,NEIG)
!
         IF(NPFLG.GT.0)CALL PRTHD(NT,NHD,NAME,NHE,DTNUC,NEIG,EIG,NFT1)
         DO K=1, NSTAT+nhd(10)
            READ(NFT)
         END DO
!
      END DO
      RETURN
!
 50   IF(NTH.NE.0)THEN
         NALM=1
      ELSE
         NTH=NSET+1
         BACKSPACE NFT
      END IF
      RETURN
      END SUBROUTINE MOVEW


      SUBROUTINE MOVEP(NFT,NTH,NALM,NPFLG,NFT1)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      USE scatci_data, ONLY : MEIG
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: NALM, NFT, NFT1, NPFLG, NTH
      INTENT (IN) NFT, NFT1, NPFLG
      INTENT (OUT) NALM
      INTENT (INOUT) NTH
!
! Local variables
!
      REAL(KIND=wp) :: E0, S, SZ
      REAL(KIND=wp), DIMENSION(MEIG) :: EIG
      CHARACTER(LEN=32) :: HEADER
      INTEGER :: I, IDUM, J, K, M, MGVN, NEIG, NELT, NNUC, NOCSF, NREC, &
     &           NSTAT, NT
      CHARACTER(LEN=120) :: NAME
      LOGICAL :: OPN
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     MOVEP LOCATES THE NTH-DATASET CONTAINED ON THE ALCHEMY CI
!           DUMPFILE (for polyatomics) ASSOCIATED WITH UNIT NFT
!
!           NPFLG = 0     NO PRINTOUT DURING SEARCH
!                 = 1     PRINT HEADER LABELS ENCOUNTERED
!           NALM  = 0     NO ERRORS DETECTED
!                 = 1     ERRORS DETECTED
!
!***********************************************************************
!
!
      NALM=0
      INQUIRE(UNIT=nft,OPENED=opn)
      IF(opn)THEN
         REWIND NFT
      ELSE
         OPEN(UNIT=nft,FORM='unformatted')
      END IF
      IF(NTH.EQ.1)RETURN
      M=NTH-1
      IF(NTH.EQ.0)M=2000
      DO I=1, M
         READ(NFT,END=50)header
         READ(NFT,END=50)NT, nrec, NAME, nnuc, nocsf, nstat, mgvn, s, &
     &                   sz, nelt, e0
         DO K=1, NNUC
            READ(NFT)
         END DO
!
         NEIG=MIN(MEIG,NSTAT)
         READ(NFT)(IDUM,J=1,nocsf), (EIG(J),J=1,NEIG)
!
         IF(NPFLG.GT.0)THEN
            WRITE(NFT1,104)header
            WRITE(NFT1,100)NT, name
            WRITE(nft1,103)mgvn, s, sz, nelt, nnuc
            WRITE(NFT1,101)nocsf, nstat, e0
            WRITE(NFT1,102)(EIG(J)+E0,J=1,NEIG)
         END IF
 104     FORMAT(/' Header:',4x,a)
 100     FORMAT(/' SET',I4,4X,A)
 101     FORMAT(/' NOCSF=',I5,4X,'NSTAT=',I5,4X,'EN   =',F20.10)
 103     FORMAT(/' MGVN =',I2,4x,'s =',f6.1,4x,'sz =',f6.1,4x,'NELT =', &
     &          I5,4x,'NNUC =',I3)
 102     FORMAT(/' EIGEN-ENERGIES',/(16X,5F20.10))
!
         DO K=1, NSTAT
            READ(NFT)
         END DO
!
      END DO
      RETURN
!
 50   IF(NTH.NE.0)THEN
         NALM=1
      ELSE
         NTH=NT+1
!        BACKSPACE NFT
      END IF
      RETURN
      END SUBROUTINE MOVEP

!*==civio.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE CIVIO(NFT,NRW,NK,NS,EI,CV,NALM,iphz,dg)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: NALM, NFT, NK, NRW, NS
      REAL(KIND=wp), DIMENSION(nk,ns) :: CV
      REAL(KIND=wp), DIMENSION(nk) :: DG
      REAL(KIND=wp), DIMENSION(ns) :: EI
      INTEGER, DIMENSION(nk) :: IPHZ
      INTENT (IN) DG, NFT, NK, NRW, NS
      INTENT (OUT) NALM
      INTENT (INOUT) CV, EI, IPHZ
!
! Local variables
!
      INTEGER :: I, J, M
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     CIVIO CONTROLS THE I/O OF CI COEFFICIENTS AND STATE DATA
!
!***********************************************************************
!
!
!     Read/Write ENERGY AND CSF SPECIFICATION FOR EACH CI STATE
!     annd then Read/Write COEFFICIENTS FOR EACH CI STATE
      NALM=0
      IF(NRW.EQ.0)THEN
         WRITE(NFT,ERR=200)iphz, EI, dg
         DO i=1, ns
            WRITE(NFT,ERR=200)i, (CV(j,i),j=1,nk)
         END DO
      ELSE
         READ(NFT,ERR=200)iphz, EI
         DO i=1, ns
            READ(NFT,ERR=200)M, (CV(j,i),j=1,nk)
         END DO
      END IF
      RETURN
!
 200  nalm=1
      RETURN
      END SUBROUTINE CIVIO


      SUBROUTINE PRTHD(NSET,NHD,HEAD,NHE,DTNUC,NEIG,EIG,NFT)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      CHARACTER(LEN=*) :: HEAD
      INTEGER :: NEIG, NFT, NSET
      REAL(KIND=wp), DIMENSION(41) :: DTNUC
      REAL(KIND=wp), DIMENSION(*) :: EIG
      INTEGER, DIMENSION(10) :: NHD
      INTEGER, DIMENSION(20) :: NHE
      INTENT (IN) DTNUC, EIG, HEAD, NEIG, NFT, NHD, NHE, NSET
!
! Local variables
!
      REAL(KIND=wp) :: E0
      INTEGER :: I, ND
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     PRTHD PRINTS THE HEADER RECORDS FROM AN ALCHEMY PERMANENT DATASET
!           FOR STORING CI EIGENVALUES AND EIGENVECTORS
!
!***********************************************************************
!
!
      WRITE(NFT,100)NSET, HEAD
      E0=DTNUC(1)
      WRITE(NFT,101)NHD, E0
      WRITE(NFT,103)(NHE(I),I=1,NHD(4))
      ND=21+NHD(9)
      IF(nd.GT.200 .OR. nd.LE.0)nd=24
      WRITE(NFT,105)(DTNUC(I),I=22,ND)
      ND=1+NHD(9)
      IF(nd.GT.200 .OR. nd.LE.0)nd=4
      WRITE(NFT,104)(DTNUC(I),I=2,ND)
      WRITE(NFT,102)(EIG(I)+E0,I=1,NEIG)
!
      RETURN
!
 100  FORMAT(' SET',I4,4X,A)
 101  FORMAT(10X,'ICVC =',I5,4X,'NOCSF=',I5,4X,'NSTAT=',I5,4X,'NSYM =', &
     &       I5,4X,'IDFLG=',2I5/10X,'IDEN =',I5,4X,'NHDIM=',I5,4X, &
     &       'NNUC =',I5,4X,'LDEN =',I5,4X,'EN   =',F20.10)
 102  FORMAT(10X,'EIGEN-ENERGIES',/(16X,5F20.10))
 103  FORMAT(10X,'NOB  =',20I5)
 104  FORMAT(10X,'CHARG=',10F10.4/(16X,10F10.4))
 105  FORMAT(10X,'XNUC =',10F10.4/(16X,10F10.4))
!
      END SUBROUTINE PRTHD

!*==cirmat.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE CIRMAT(NTGsym,NFTG,NTGTF,CTGT,etgt,NTGTS,NCTGT,NFT, &
     &                  numtgt,iphz,nctarg,symtyp)
!
      USE precisn, ONLY : wp ! for specifying the kind of reals
      USE consts, ONLY : ZERO=>XZERO, ONE=>XONE
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: NCTARG, NFT, NFTG, NTGSYM, SYMTYP
      REAL(KIND=wp), DIMENSION(*) :: CTGT, ETGT
      INTEGER, DIMENSION(*) :: IPHZ, NCTGT, NTGTF, NTGTS, NUMTGT
      INTENT (IN) NCTARG, NTGSYM, NTGTF, NUMTGT, SYMTYP
!
! Local variables
!
      REAL(KIND=wp), DIMENSION(41) :: DTNUC1
      REAL(KIND=wp) :: S, SZ
      INTEGER :: MGVN, NELT
      REAL(KIND=wp), ALLOCATABLE, DIMENSION(:) :: EIG, VC
      INTEGER :: IFL, IFNUM, II, IST, ITGT, JTGT, LST, NHDIM, NOCSF1, &
     &           NPHZ, NSTAT, ERR
      INTEGER, ALLOCATABLE, DIMENSION(:) :: KPHZ
      CHARACTER(LEN=120) :: NAME
      INTEGER, DIMENSION(10) :: NHD1
      INTEGER, DIMENSION(20) :: NHE1
!
!*** End of declarations rewritten by SPAG
!
!     PROCESS DATA FOR HAMILTONIAN CONTRACTION IN R-MATRIX CI
!
      IFNUM=0
      ist=0
      lst=0
      ifl=0
      nphz=1
!
!     OBTAIN CI COEFFICIENTS FROM DUMPFILE FOR H-TRANSFORMATION
!
      DO Itgt=1, ntgsym
         nstat=numtgt(itgt)
         DO ii=1, numtgt(itgt)
            nstat=max(nstat,NTGTS(IFL+ii))
         END DO
         DO jtgt=1, numtgt(itgt)
            ifl=ifl+1
!
!     DETERMINE FILE NUMBER AND POSITION AT START OF DATASET
!
            IF(NTGTF(IFL).GT.0)THEN
               WRITE(NFT,2182)IFL, NTGTF(IFL), NTGTS(IFL)
!
!     Do we need to find another set of target vectors ?
               IF(IFNUM.NE.NTGTF(IFL))THEN
                  IFNUM=NTGTF(IFL)
!
                  nhdim=nctgt(itgt)
                  IF (ALLOCATED(kphz)) DEALLOCATE(kphz)
                  IF (ALLOCATED(eig)) DEALLOCATE(eig)
                  IF (ALLOCATED(vc)) DEALLOCATE(vc)
                  ALLOCATE(kphz(nhdim),eig(nhdim),vc(nhdim*nstat), &
     &                     stat=ERR)
                  IF (ERR.ne.0) THEN
                     print *,'CIRMAT: memory allocation error'
                     stop
                  ENDIF
!
!     READ CI COEFFICIENTS
!
                  IF(symtyp.LT.2)THEN
                     CALL READCID(nftg,ifnum,NAME,NHE1,NHD1,DTNUC1, &
     &                            NOCSF1,NSTAT,nctgt(itgt),EIG,VC,kphz, &
     &                            NFT)
                  ELSE
                     CALL READCIP(nftg,ifnum,NOCSF1,NSTAT,nctgt(itgt), &
     &                            mgvn,s,sz,nelt,EIG,VC,kphz,NFT)
                  END IF
               END IF

            END IF
!
!     SELECT AND PACK CI COEFFICIENTS FOR H-TRANSFORMATION
!
            IF(nctarg.LE.0)THEN
               CALL CPAK(NTGTS(IFL),NOCSF1,VC,eig,CTGT,etgt,ist,lst)
            ELSE
!        .... also introducing phase correction from CONGEN
!
               CALL CPAKPZ(NTGTS(IFL),NOCSF1,VC,eig,CTGT,etgt,ist,lst, &
     &                     iphz(nphz),kphz)
            END IF
!
         END DO
         nphz=nphz+nocsf1
      END DO
!     successful completion
      IF(nphz-1.EQ.nctarg .OR. nctarg.EQ.0)RETURN
!
      WRITE(nft,2180)nphz-1, nctarg
 2180 FORMAT(/' Target data from CI file not consistent with data', &
     &       ' from CONGEN',/' Total number of target CSFs here =',i6, &
     &       ' from CONGEN =',i6)
!
      STOP
 2182 FORMAT(/' TRANSFORMATION VECTOR ',I3,' FROM SET',I3,' STATE',I3)
 2183 FORMAT(/' TRANSFORMATION VECTOR ',I3,' IS FOR AN SCF STATE')
!
      END SUBROUTINE CIRMAT


!*==cpak.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE CPAK(K,NOSCF,CIV,eig,C,e,i,l)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: I, K, L, NOSCF
      REAL(KIND=wp), DIMENSION(*) :: C, E, EIG
      REAL(KIND=wp), DIMENSION(NOSCF,*) :: CIV
      INTENT (IN) CIV, EIG, K, NOSCF
      INTENT (OUT) C, E
      INTENT (INOUT) I, L
!
! Local variables
!
      INTEGER :: J
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     CPAK ACCUMULATES THE CI EIGENVECTOR EXPANSION COEFFICIENTS
!          FOR THE TARGET EIGENSTATES IN A PACKED FORM SUITABLE
!          for CI contraction in subroutine ENRGMX
!
!***********************************************************************
!
!
      l=l+1
      e(l)=eig(k)
!
      DO J=1, NOSCF
         I=I+1
         C(I)=CIV(J,K)
      END DO
!
      RETURN
!
      END SUBROUTINE CPAK
!*==cpakpz.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE CPAKPZ(K,NOSCF,CIV,eig,C,e,i,l,iphz,iphz0)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: I, K, L, NOSCF
      REAL(KIND=wp), DIMENSION(*) :: C, E, EIG
      REAL(KIND=wp), DIMENSION(NOSCF,*) :: CIV
      INTEGER, DIMENSION(noscf) :: IPHZ, IPHZ0
      INTENT (IN) CIV, EIG, IPHZ, IPHZ0, K, NOSCF
      INTENT (OUT) C, E
      INTENT (INOUT) I, L
!
! Local variables
!
      INTEGER :: J
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     CPAKPZ ACCUMULATES THE CI EIGENVECTOR EXPANSION COEFFICIENTS
!          FOR THE TARGET EIGENSTATES IN A PACKED FORM SUITABLE
!          for CI contraction in subroutine ENRGMX
!     Also include the phase correction contained in array iphz
!
!***********************************************************************
!
!
      l=l+1
      e(l)=eig(k)
      DO J=1, NOSCF
         I=I+1
         C(I)=CIV(J,K)*REAL(iphz(j)*iphz0(j),KIND=wp)
      END DO
!
      RETURN
!
      END SUBROUTINE CPAKPZ








      SUBROUTINE ham_pars_io(write_ham_pars,lcont,ntgcon,numtgt,notgt,    &
     &                       mcont,nfte,nelm,symtyp,s,sz,nelt,mgvn,nfti,  &
     &                       kphz,size_kphz,ukrmolp_ints)
!     Reads or writes the file 'ham_data' containing the parameters needed on the call to dgmain
!     if write_ham_pars .eq. .true. then the file is written interpretting the arguments as input
!     and if write_ham_pars .eq. .false. then the file is read in interpretting the argumens as output
      USE precisn, ONLY : wp
      USE scatci_data, ONLY : NTGTMX
      IMPLICIT NONE
!     Argument input/output
      LOGICAL, INTENT(IN) :: write_ham_pars
      INTEGER, INTENT(INOUT) :: NTGCON, NFTE, NELM, SYMTYP, NELT, MGVN, &
     &                       NFTI, LCONT, size_kphz
      INTEGER, DIMENSION(ntgtmx), INTENT(INOUT) :: MCONT, NOTGT, NUMTGT
      INTEGER, ALLOCATABLE, INTENT(INOUT) :: kphz(:)
      LOGICAL, INTENT(INOUT) :: ukrmolp_ints
      REAL(KIND=wp), INTENT(INOUT) :: S, SZ
!     Local variables
      INTEGER :: ihd, err
!
      ihd = 444
      if (write_ham_pars) then
         open(unit=ihd,file='ham_data',status='replace', &
     &        form='unformatted',iostat=err)
      else
         open(unit=ihd,file='ham_data',status='old', &
     &        form='unformatted',iostat=err)
      endif

      if (err .ne. 0) then
         stop "Error opening/creating the file ham_data."
      endif

      if (write_ham_pars) then
         write(*,'(/,"Writing ham_data...")')
         write(ihd)lcont,ntgcon,numtgt,notgt,mcont,nfte,nelm,symtyp,s,sz &
     &             ,nelt,mgvn,nfti,size_kphz,ukrmolp_ints
         if (.not.(allocated(kphz))) then
            stop "On input the array kphz has not been allocated."
         else
            write(ihd) kphz(1:size_kphz)
         endif
         write(*,'("Done")')

      else
         write(*,'(/,"Reading ham_data...")')
         read(ihd) lcont,ntgcon,numtgt,notgt,mcont,nfte,nelm,symtyp,s,sz &
     &             ,nelt,mgvn,nfti,size_kphz,ukrmolp_ints

         if (allocated(kphz)) deallocate(kphz)
         allocate(kphz(1:size_kphz),stat=err)
         if (err .ne. 0) stop "Memory allocation failed."
         kphz(1:size_kphz) = 0

         read(ihd) kphz(1:size_kphz)

         write(*,'("Done")')
      endif

      close(ihd)

      return

      END SUBROUTINE ham_pars_io


      SUBROUTINE RDINT(IMIN,IMAX,NEND,IMAXP,NFTA,IA,ILST,XINT)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: IA, ILST, IMAX, IMAXP, IMIN, NEND, NFTA
      REAL(KIND=wp)	:: XINT(:)
      INTENT (IN) ILST, IMAXP, NFTA
      INTENT (INOUT) IA, IMAX, IMIN, NEND, XINT
!
! Local variables
!
      INTEGER :: I, IB, IC, K, KC
      INTEGER, SAVE :: KA, KB
      INTEGER, DIMENSION(14), SAVE :: NPAR
!
!*** End of declarations rewritten by SPAG
!
!     Read Alchemy 2e integrals
!
!     NFTA          FILE NO. OF INTEGRAL TAPE
!     IA            INITIAL INDEX FOR XINT
!     ILST          DIMENSION OF XINT
!     IMIN          INITIAL INDEX OF THE CURRENT BLOCK
!     IMAX          LAST    INDEX OF THE CURRENT BLOCK
!     XINT(ILST)
!     NEND          =0,  MORE INTEGRALS
!                   =1,  END OF FILE
!                   =2,  ERROR
!
      IF(nend.EQ.-1)THEN
         nend=0
         GO TO 100
      END IF
!
      IB=IMAX-IMAXP
      IF(IB.GT.0)THEN
         IC=IMAXP-IMIN+1
         DO I=1, IB
            XINT(I)=XINT(IC+I)
         END DO
         IA=IB+1
      END IF
      IMAX=IMAXP
      IF(NEND.EQ.1)GO TO 300
!
 110  KC=KA
      IF(NPAR(2).NE.NPAR(4) .OR. NPAR(3).NE.NPAR(5))THEN
         DO K=KC, KB
            IB=IA+NPAR(10)-1
            IF(IB.GT.ILST)THEN
               KA=K
               GO TO 200
            ELSE
               READ(NFTA)(XINT(I),I=IA,IB)
            END IF
            IA=IB+1
         END DO
      ELSE
         DO K=KC, KB
            IB=IA+K-1
            IF(IB.GT.ILST)THEN
               KA=K
               GO TO 200
            ELSE
               READ(NFTA)(XINT(I),I=IA,IB)
            END IF
            IA=IB+1
         END DO
      END IF
!
 100  READ(NFTA,END=300,ERR=400)NPAR
      KA=1
      KB=NPAR(11)
      GO TO 110
!
 300  NEND=1
      REWIND NFTA
!
 200  IMIN=IMAX+1
      IMAX=IMIN+IA-2
      IA=1
      RETURN
!
 400  NEND=2
      RETURN
      END SUBROUTINE RDINT

!*==rdints.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE RDINTS(NFTA,NSYM,NOB,LTRIB,ILST,IA,XINT,NALM)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: IA, ILST, LTRIB, NALM, NFTA, NSYM
      INTEGER, DIMENSION(*) :: NOB
      REAL(KIND=wp) :: XINT(:)
      INTENT (IN) ILST, LTRIB, NOB, NSYM
      INTENT (INOUT) IA, NALM
!
! Local variables
!
      INTEGER :: IB, L, LTRI, N, NINT, NT
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     Reads the one electron integrals for each symmetry.
!
!     Input:
!
!      NFTA  Logical unit holding the integrals
!      NSYM  Number of symmetries in the wavefunction
!       NOB  Number of orbitals per symmetry
!     LTRIB  The number of words per record on file NFTA
!      ILST  Highest storage positin to be used in array XINT
!        IA  Initial storage position to be used in array XINT
!
!     Output:
!
!       XINT  Vector holding the integrals themselves
!       NALM  Return code (0= Success ; 1= failure)
!
!***********************************************************************
!
!
!---- Descend into loop over symemtries. Note that NINT is the number
!     of one electron integrals per symmetry. Integrals are blocked
!     in units of LTRI so that more than one record is possible. See
!     routine RDINS to understand why LTRI=LTRIB-3.
!
      LTRI=LTRIB-3
      DO L=1, NSYM
         NINT=(NOB(L)*(NOB(L)+1))/2
         IF(NINT.EQ.0)CYCLE
!
!....... Loop over records of integrals and read each one. Uses
!        auxiliary routine for this.
!
         DO N=1, NINT, LTRI
            IB=N+LTRI-1
            IF(IB.GT.NINT)IB=NINT
            NT=IB-N+1
            IF(IA+NT.GT.ILST)THEN
! Error condition
               NALM=1
               RETURN
            END IF
            CALL RDINS(NFTA,XINT(IA:IA+NT-1),NT,NALM)
            IF(NALM.NE.0)RETURN
            IA=IA+NT
         END DO
      END DO
      RETURN
      END SUBROUTINE RDINTS

!*==rdins.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE RDINS(NFTA,XINT,NT,NALM)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: NALM, NFTA, NT
      REAL(KIND=wp) :: XINT(NT)
      INTENT (IN) NFTA, NT
      INTENT (INOUT) NALM, XINT
!
! Local variables
!
      INTEGER :: NA, NB, NC
!
!*** End of declarations rewritten by SPAG
!
!***********************************************************************
!
!     Reads vector XINT of length NT from file NFTA along with
!     three other constants which are not returned. Used to read
!     transformed integrals for Hamiltonian construction
!
!***********************************************************************
!
      NALM=0
      READ(NFTA,END=200,ERR=200)NA, NB, NC, XINT
!
!---- Standard return
!
      RETURN
!
!---- Error condition
!
 200  NALM=2
      RETURN

      end subroutine

!*==prci.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE PRCI(NOCSF,NSTATE,EE,ET,XR,CR,NCIPFG,NKEY,KEYCSF,LARGE, &
     &                THRPRT,NFT)
!
      USE precisn, ONLY : wp ! for specifying the kind of reals
      USE consts, ONLY : ZERO=>XZERO
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      REAL(KIND=wp) :: ET, THRPRT, XR
      INTEGER :: LARGE, NCIPFG, NFT, NKEY, NOCSF, NSTATE
      REAL(KIND=wp), DIMENSION(nocsf,*) :: CR
      REAL(KIND=wp), DIMENSION(*) :: EE
      INTEGER, DIMENSION(2) :: KEYCSF
      INTENT (IN) KEYCSF, NCIPFG, NKEY, NSTATE, THRPRT
      INTENT (INOUT) LARGE
!
! Local variables
!
      REAL(KIND=wp), DIMENSION(10) :: CBIG
      REAL(KIND=wp), DIMENSION(20) :: CKEY, CKEY2, CSUMC
      REAL(KIND=wp) :: CSUMR
      INTEGER :: I, I1, INC, J, KC, NKEYN, NKF, NS, NSF, NSI
      INTEGER, DIMENSION(10) :: IBIG
      character(len=4) :: IBL='    '
      INTEGER, DIMENSION(20) :: KCSFI
!
!*** End of declarations rewritten by SPAG
!
      NKF=MIN(NKEY,20)
      LARGE=MIN(LARGE,10)
      IF(NKF.LE.0)GO TO 35
!
      I1=0
      DO I=1, NKF
         KC=KEYCSF(I) ! JMC are the array bounds really OK here for keycsf???
         DO J=1, nocsf
            IF(KC.EQ.J)GO TO 20
         END DO
         CYCLE
 20      I1=I1+1
         KCSFI(I1)=KC
      END DO
      NKF=I1
!
 35   IF(NCIPFG.NE.1)GO TO 200
      IF(NKF.LE.0)GO TO 120
!
      DO I=1, NKF
         CSUMC(I)=ZERO
      END DO
!
      NSF=0
 50   WRITE(NFT,60)NOCSF, (KCSFI(I),I=1,NKF)
 60   FORMAT('1EIGENVECTOR RECAPITULATION  NOCSF =',I6,/,9X,'ENERGY',3X, &
     &       10I9/18X,10I9)
      WRITE(NFT,65)
 65   FORMAT(' ')
!
      NSI=NSF+1
      INC=20
      IF(NKF.GE.10)INC=10
      NSF=MIN(NSF+INC,NSTATE)
!
      DO I=NSI, NSF
         CSUMR=ZERO
         DO J=1, NKF
            CKEY(J)=CR(KCSFI(J),I)
            CKEY2(J)=CKEY(J)*CKEY(J)
            CSUMC(J)=CSUMC(J)+CKEY2(J)
            CSUMR=CSUMR+CKEY2(J)
         END DO
         WRITE(NFT,85)I, EE(I)+ET, (CKEY(J),J=1,NKF)
 85      FORMAT(I4,F14.6,2X,10F9.4/22X,10F9.4)
         WRITE(NFT,105)(IBL,CKEY2(J),J=1,NKF), IBL, CSUMR
 105     FORMAT(21X,10(A1,'(',F6.3,')')/21X,11(A1,'(',F6.3,')'))
         WRITE(NFT,65)
      END DO
      IF(NSF.LT.NSTATE)GO TO 50
      WRITE(NFT,115)(CSUMC(J),J=1,NKF)
 115  FORMAT(13X,'SUMS',3X,10F9.4/28X,10F9.4)
!
!     PRINT LARGE COEFFICIENTS
!
 120  IF(LARGE.LE.0)GO TO 200
      WRITE(NFT,121)
 121  FORMAT(//)
      DO NS=1, NSTATE
         DO I=1, LARGE
            CBIG(I)=ZERO
            IBIG(I)=0
         END DO
         DO I=1, LARGE
            DO J=1, nocsf
!
               IF(ABS(CR(J,NS)).LE.ABS(CBIG(I)))CYCLE
               IF(I.GT.1)THEN
                  IF(ABS(CR(J,NS)).EQ.ABS(CBIG(I-1)))THEN
                     IF(J.LE.IBIG(I-1))CYCLE
                  ELSE IF(ABS(CR(J,NS)).GT.ABS(CBIG(I-1)))THEN
                     CYCLE
                  END IF
               END IF
               IBIG(I)=j
               CBIG(I)=CR(J,NS)
            END DO
         END DO
!
         IF(NKF.GT.0)THEN
            DO I=1, NKF
               CKEY(I)=CR(KCSFI(I),NS)
            END DO
         END IF
!
         WRITE(NFT,165)NS, EE(NS)+ET, (IBIG(I),CBIG(I),I=1,LARGE)
 165     FORMAT(I4,F14.6,3X,10(I4,F7.3))
         IF(NKF.GT.0)WRITE(NFT,170)(KCSFI(J),CKEY(J),J=1,NKF)
 170     FORMAT(21X,10(I4,F7.3))
         WRITE(NFT,65)
      END DO
 200  IF(NCIPFG.EQ.2 .AND. NKF.GT.0)THEN
         NKEYN=0
         DO NS=1, NSTATE
            CSUMR=ZERO
            DO I=1, NKF
               CSUMR=CSUMR+CR(KCSFI(I),NS)*CR(KCSFI(I),NS)
            END DO
            IF(CSUMR.LT.THRPRT)CYCLE
            NKEYN=NKEYN+1
!
            CALL PRCIVC(NOCSF,NS,EE(NS),ET,XR,CR(1,NS),NFT)
!
         END DO
      END IF
!
      IF(NCIPFG.EQ.3)THEN
         DO NS=1, NSTATE
            CALL PRCIVC(NOCSF,NS,EE(NS),ET,XR,CR(1,NS),NFT)
         END DO
      END IF
!
      RETURN
      END SUBROUTINE PRCI
!*==prcivc.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE PRCIVC(NOCSF,NSTAT,EE,EN,XR,CIV,NFT)
      USE precisn, ONLY : wp ! for specifying the kind of reals
      IMPLICIT NONE
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      REAL(KIND=wp) :: EE, EN, XR
      INTEGER :: NFT, NOCSF, NSTAT
      REAL(KIND=wp), DIMENSION(50,*) :: CIV
      INTENT (IN) CIV, EE, EN, NFT, NOCSF, NSTAT, XR
!
! Local variables
!
      REAL(KIND=wp) :: ED, ET
      INTEGER :: I, IA, IMAX, J, JA, JB, JMAX
!
!*** End of declarations rewritten by SPAG
!
      ET=EE+EN
      ED=ET-XR
      WRITE(NFT,500)NOCSF, NSTAT
      WRITE(NFT,510)EE, ET, XR, ED
!
      JMAX=(nocsf-1)/50+1
      IMAX=nocsf-50*(JMAX-1)
      JA=1
!
 200  JB=JA+7
      IF(JB.GE.JMAX)GO TO 300
      WRITE(NFT,520)((50*(j-1)+i,CIV(I,J),J=JA,JB),I=1,50)
      JA=JB+1
      WRITE(NFT,530)
      GO TO 200
!
 300  IA=1
 310  DO I=IA, IMAX
         WRITE(NFT,520)(50*(j-1)+I,CIV(I,J),J=JA,JMAX)
      END DO
      IF(IMAX.EQ.50 .OR. JA.EQ.JMAX)RETURN
      JMAX=JMAX-1
      IA=IMAX+1
      IMAX=50
      GO TO 310
!
      RETURN
!
 500  FORMAT('1 NOCSF=',I6,8X,' STATE',I5,9X,//,5X,'E (ELECTRONIC)',11X, &
     &       'E (TOTAL)',7X,'E (REFERENCE)',6X,'E (DIFFERENCE)')
 510  FORMAT(/F19.8,3F20.8,/)
 520  FORMAT((1X,8(I5,F11.6)))
 530  FORMAT('1'/'0'/'0'/'0')
      END SUBROUTINE PRCIVC

end module
