



!*==remx.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE REMX(MXU,NELM,IJ,EMX,NBUF)
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: MXU, NBUF, NELM
      REAL(KIND=wp), DIMENSION(NBUF) :: EMX
      INTEGER, DIMENSION(2,NBUF) :: IJ
      INTENT (IN) MXU, NBUF
      INTENT (OUT) EMX, IJ, NELM
C
C*** End of declarations rewritten by SPAG
C
C***********************************************************************
C
C     REMX READS THE FILE OF NONZERO HAMILTONIAN MATRIX ELEMENTS
C
C***********************************************************************
C
C
      READ(MXU)NELM, IJ, EMX
C
      RETURN
C
      END SUBROUTINE REMX



!*==geth.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE GETH(H,ndim,emx,IJ2,nbuf,nfte,NFT)
C
C***********************************************************************
C
C     GETH READS THE NONZERO ENERGY MATRIX ELEMENTS AND CONSTRUCTS
C          THE LOWER TRIANGULAR THE HAMILTONIAN  MATRIX
C
C***********************************************************************
C
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: NBUF, NDIM, NFT, NFTE
      REAL(KIND=wp), DIMENSION(nbuf) :: EMX
      REAL(KIND=wp), DIMENSION(ndim,ndim) :: H
      INTEGER, DIMENSION(2,nbuf) :: IJ2
      INTENT (IN) NDIM, NFT
      INTENT (OUT) H
C
C Local variables
C
      INTEGER :: L, LREAD, NELM
C
C*** End of declarations rewritten by SPAG
C
      lread=0
      L=0
      nelm=0
 311  IF(L.EQ.NELM)THEN
         CALL REMX(nfte,NELM,IJ2,EMX,NBUF)
         lread=lread+nelm
         IF(NELM.EQ.0)GO TO 312
         L=0
      END IF
      L=L+1
      IF(max(ij2(1,l),ij2(2,l)).GT.ndim)WRITE(NFT,*)
     &   'HELP: attemp to create element', ij2(1,l), ij2(2,l)
      H(ij2(1,l),ij2(2,l))=EMX(L)
      GO TO 311
C
 312  CLOSE(nfte)
      WRITE(NFT,100)lread, NFTE
 100  FORMAT(/,I10,' Hamiltonian elements read from unit NFTE =',i3)
C
      RETURN
      END SUBROUTINE GETH
!*==hmat.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE HMAT(EMX,NTGT,NOTGT,ESHIFT,nshift,NHDIM,NFT,nfte,nbuf,
     &                eone)
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      USE consts, ONLY : ZERO=>XZERO
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      REAL(KIND=wp) :: EONE
      INTEGER :: NBUF, NFT, NFTE, NHDIM, NSHIFT, NTGT
      REAL(KIND=wp), DIMENSION(nhdim,nhdim) :: EMX
      REAL(KIND=wp), DIMENSION(ntgt) :: ESHIFT
      INTEGER, DIMENSION(ntgt) :: NOTGT
      INTENT (IN) ESHIFT, NOTGT, NSHIFT, NTGT
      INTENT (OUT) EONE
      INTENT (INOUT) EMX
C
C Local variables
C
      REAL(KIND=wp), DIMENSION(NBUF) :: BUF
      REAL(KIND=wp) :: ES
      INTEGER :: I, J, K
      INTEGER, DIMENSION(2,NBUF) :: IJ
C
C*** End of declarations rewritten by SPAG
C
C
C*********************************************************************
C
C     HMAT CONSTRUCTS FULL HAMILTONIAN MATRIX... UPPER TRIANGLE BUT
C     INCLUDING ZERO ELEMENTS for Givens-Householder diagonalisation
C
C*********************************************************************
C
C     READ ENERGY MATRIX ELEMENTS
C
 
      emx=zero
 
      CALL geth(emx,nhdim,BUF,ij,nbuf,nfte,NFT)
C
      IF(NSHIFT.GT.0)THEN
         WRITE(NFT,246)NSHIFT, (ESHIFT(I),I=1,NTGT)
         K=0
         DO I=1, NTGT
            ES=ESHIFT(I)
            DO J=1, NOTGT(I)
               k=k+1
               emx(K,k)=emx(K,k)+ES
            END DO
         END DO
      END IF
      eone=emx(1,1)
C
      RETURN
C
 246  FORMAT(/' APPLYING THRESHOLD SHIFTS TO',I3,
     &       ' TARGET STATES'/' ESHIFT',10F10.5/(7X,10F10.5))
      END SUBROUTINE HMAT
!*==ldhama.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE LDHAMA(elem,lj1,lj2,ndim,nfte,nbuf,nfta)
C
C***********************************************************************
C
C     LDHAMA READS THE NONZERO ENERGY MATRIX ELEMENTS
C     and, if room (INCORE=1) stores elements in elem
c     in preparation for Arpack diagonalisation
C***********************************************************************
C
      USE precisn, ONLY : wp ! for specifying the kind of reals                        

      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: NBUF, NDIM, NFTA, NFTE
      REAL(KIND=wp), DIMENSION(*) :: ELEM
      INTEGER, DIMENSION(*) :: LJ1, LJ2
      INTENT (IN) NDIM, NFTA
      INTENT (OUT) ELEM, LJ1, LJ2
C
C Local variables
C
      REAL(KIND=wp), DIMENSION(nbuf) :: EMX
      INTEGER, DIMENSION(2,nbuf) :: IJ2
      INTEGER :: L, LOFF, NELM
C
C*** End of declarations rewritten by SPAG
C
      L=0
      nelm=0
      loff=0
 311  IF(L.EQ.NELM)THEN
         CALL REMX(nfte,NELM,IJ2,EMX,NBUF)
         IF(NELM.EQ.0)GO TO 312
         L=0
      END IF
      L=L+1
      IF(max(ij2(1,l),ij2(2,l)).GT.ndim .OR. min(ij2(1,l),ij2(2,l))
     &   .LT.1)THEN
         WRITE(NFTA,*)' HELP: attempt to create element', ij2(1,l), 
     &                ij2(2,l), loff, l
         STOP
      END IF
      loff=loff+1
      elem(loff)=EMX(L)
      lj1(loff)=ij2(1,l)
      lj2(loff)=ij2(2,l)
      GO TO 311
C
 312  CLOSE(nfte)
      WRITE(NFTA,100)loff, NFTE
 100  FORMAT(/,I10,' Hamiltonian elements read from unit NFTE =',i3)
C
      RETURN
      END SUBROUTINE LDHAMA
!*==ldhamb.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE LDHAMB(ndim,nfte,nbuf,nfta,loff)
C
C***********************************************************************
c     LDHAMB counts the number of nonzero elements of the Hamiltonian
c     matrix. This is needed in case of a restart of the ARPACK
c     diagonalization as we skip over the Hamiltonian matrix contruction
c     phase. The Hamiltonian matrix recalculation can be avoided in case of
c     an ARPACK restart by setting ICIDG=2 in the SCATCI &INPUT namelist.
c     Date: 4/09/2008, Amar Dora.
 
C***********************************************************************
C
      USE precisn, ONLY : wp ! for specifying the kind of reals                        

      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: LOFF, NBUF, NDIM, NFTA, NFTE
      INTENT (IN) NDIM, NFTA
      INTENT (INOUT) LOFF
C
C Local variables
C
      REAL(KIND=wp), DIMENSION(nbuf) :: EMX
      INTEGER, DIMENSION(2,nbuf) :: IJ2
      INTEGER :: L, NELM
C
C*** End of declarations rewritten by SPAG
C
      L=0
      nelm=0
      loff=0
 311  IF(L.EQ.NELM)THEN
         CALL REMX(nfte,NELM,IJ2,EMX,NBUF)
         IF(NELM.EQ.0)GO TO 312
         L=0
      END IF
      L=L+1
      IF(max(ij2(1,l),ij2(2,l)).GT.ndim .OR. min(ij2(1,l),ij2(2,l))
     &   .LT.1)THEN
         WRITE(NFTA,*)' HELP: attempt to create element', ij2(1,l), 
     &                ij2(2,l), loff, l
         STOP
      END IF
      loff=loff+1
      GO TO 311
C
 312  CONTINUE
      REWIND nfte
      READ(nfte)
C
      RETURN
      END SUBROUTINE LDHAMB
!*==ldham.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE LDHAM(diag,offdg,lj1,lj2,ndim,nfte,nbuf,incore,nfta)
C
C***********************************************************************
C
C     LDHAM READS THE NONZERO ENERGY MATRIX ELEMENTS
C     Stores diagonals in DIAG
C     and, if room (INCORE=1) stores off-diagonals in OFFDG
c     in preparation for Davidson diagonalisation
C***********************************************************************
C
      USE precisn, ONLY : wp ! for specifying the kind of reals                        

      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: INCORE, NBUF, NDIM, NFTA, NFTE
      REAL(KIND=wp), DIMENSION(*) :: DIAG, OFFDG
      INTEGER, DIMENSION(*) :: LJ1, LJ2
      INTENT (IN) INCORE, NDIM, NFTA
      INTENT (OUT) DIAG, LJ1, LJ2, OFFDG
C
C Local variables
C
      REAL(KIND=wp), DIMENSION(nbuf) :: EMX
      INTEGER, DIMENSION(2,nbuf) :: IJ2
      INTEGER :: L, LOFF, LREAD, NELM
C
C*** End of declarations rewritten by SPAG
C
      IF(incore.EQ.0)lj2(1)=nfte
      lread=0
      L=0
      nelm=0
      loff=0
 311  IF(L.EQ.NELM)THEN
         CALL REMX(nfte,NELM,IJ2,EMX,NBUF)
         lread=lread+nelm
         IF(NELM.EQ.0)GO TO 312
         L=0
      END IF
      L=L+1
      IF(max(ij2(1,l),ij2(2,l)).GT.ndim .OR. min(ij2(1,l),ij2(2,l))
     &   .LT.1)THEN
         WRITE(NFTA,*)' HELP: attempt to create element', ij2(1,l), 
     &                ij2(2,l), loff, l
         STOP
      END IF
      IF(ij2(1,l).EQ.ij2(2,l))diag(ij2(1,l))=EMX(L)
      IF(incore.EQ.1)THEN
         loff=loff+1
         offdg(loff)=EMX(L)
         lj1(loff)=ij2(1,l)
         lj2(loff)=ij2(2,l)
      END IF
      GO TO 311
C
 312  CLOSE(nfte)
      WRITE(NFTA,100)lread, NFTE
 100  FORMAT(/,I10,' Hamiltonian elements read from unit NFTE =',i3)
C
      RETURN
      END SUBROUTINE LDHAM

!*==mkdvm.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE MKDVM(hmat,eig,dgem,nhdim,nume,nfta,nfte,lembf,nelm,
     &                 CRITE,CRITC,CRITR,ORTHO,maxiter,IERR)
C
C***********************************************************************
C
C     MKDVM sets up matrix elements for Davidson diagonalisation
C     and calls diagonaliser DVDSON
C     Parameter INCORE determines if matrix elements can be held in core
c     (=1) or not (=0)
C***********************************************************************
C
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      REAL(KIND=wp) :: CRITC, CRITE, CRITR, ORTHO
      INTEGER :: LEMBF, MAXITER, NELM, NFTA, NFTE, NHDIM, NUME
      REAL(KIND=wp), DIMENSION(nhdim) :: DGEM
      REAL(KIND=wp), DIMENSION(nume) :: EIG
      REAL(KIND=wp), DIMENSION(nhdim*nume) :: HMAT
      INTENT (IN) NUME
      INTENT (OUT) EIG, HMAT
      INTENT (INOUT) MAXITER
C
C Local variables
C
      LOGICAL :: HIEND
      INTEGER :: I, IERR, IERROR, IHIGH, ILOW, INCORE, IRWSZ, ITEMP, 
     &           LIM, MBLOCK, NDIM, NLOOPS, NMV
      INTEGER, ALLOCATABLE, DIMENSION(:) :: ISELE, LJ
      REAL(KIND=wp), ALLOCATABLE, DIMENSION(:) :: OFEM, WORK
      EXTERNAL OPCORE, OPDISK
C
C*** End of declarations rewritten by SPAG
C
      IERR=0
      NLOOPS=0
      NMV=0
c *** Check that there is enough space to hold all elements in core
c     calculate workspace for DVDSON routine
      LIM=MIN(NUME+20,NHDIM)
      IRWSZ=LIM*(2*NHDIM+LIM+9)+LIM*(LIM+1)/2+nume
      ALLOCATE(work(irwsz),isele(lim))
      ALLOCATE(ofem(nelm),lj(2*nelm),stat=ierror)
      IF(ierror.EQ.0)THEN
         incore=1
         WRITE(NFTA,2481)
 2481    FORMAT(' Non-zero matrix elements held in core')
         itemp=nelm
      ELSE
         incore=0
         WRITE(NFTA,2482)
 2482    FORMAT(' Non-zero matrix elements to be read from disk',
     &          ' at each iteration')
         itemp=lembf
         ALLOCATE(ofem(lembf),lj(2*lembf))
      END IF
c
c     Load diagonal elements, and others if enough room
      CALL LDHAM(dgem,ofem,lj,lj(itemp+1),nhdim,nfte,lembf,incore,nfta)
      ilow=1
      ihigh=nume
      IF(maxiter.LE.0)MAXITER=MAX(NUME*40,500)
c      write(nfta,2843)  CRITE,CRITC,CRITR,ORTHO,maxiter
c 2843 format(' CRITE =',D8.2,' CRITC =',D8.2,' CRITR =',D8.2,
c     1    ' ORTHO =',D8.2,' MAXITER =',I5)
      IF(incore.EQ.1)THEN
         mblock=1
         CALL DVDSON(opcore,nhdim,LIM,dgem,ILOW,IHIGH,ISELE,0,MBLOCK,
     &               CRITE,CRITC,CRITR,ORTHO,MAXITER,work,IRWSZ,HIEND,
     &               NLOOPS,NMV,IERR,ofem,lj,nelm)
      ELSE
         mblock=nume
         CALL DVDSON(opdisk,nhdim,LIM,dgem,ILOW,IHIGH,ISELE,0,MBLOCK,
     &               CRITE,CRITC,CRITR,ORTHO,MAXITER,work,IRWSZ,HIEND,
     &               NLOOPS,NMV,IERR,ofem,lj,lembf)
      END IF
c
      ndim=nume*nhdim
      DO i=1, ndim
         hmat(i)=work(i)
      END DO
      DO i=1, nume
         eig(i)=work(i+ndim)
      END DO
c
      WRITE(nfta,2800)NLOOPS, NMV, IERR
 2800 FORMAT(/' Davidson diagonalisation completed:'/I4,' iterations',
     &       i10,' matrix vector multiplies',' IERR =',i4)
c
      DEALLOCATE(work,isele,lj,ofem)
      RETURN
      END SUBROUTINE MKDVM
!*==mvcivc.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE MVCIVC(NOCSF,NVEC,eigs,vecs,EIG,vec)
c
c     transfer the target vectors required for later
c
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: NOCSF, NVEC
      REAL(KIND=wp), DIMENSION(nocsf) :: EIG
      REAL(KIND=wp), DIMENSION(nvec) :: EIGS
      REAL(KIND=wp), DIMENSION(nocsf,nocsf) :: VEC
      REAL(KIND=wp), DIMENSION(nocsf,nvec) :: VECS
      INTENT (IN) EIG, NOCSF, NVEC, VEC
      INTENT (OUT) EIGS, VECS
C
C Local variables
C
      INTEGER :: I, J
C
C*** End of declarations rewritten by SPAG
C
      DO i=1, nvec
         eigs(i)=eig(i)
         DO j=1, nocsf
            vecs(j,i)=vec(j,i)
         END DO
      END DO
      RETURN
      END SUBROUTINE MVCIVC
!*==mvcore.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE MVCORE(N,X,Y,A,LJ1,LJ2,NELM)
 
*=======================================================================
*
*       Computes the product of matrix A with vector x
*                               y = A x
*       where A(NxN) is a Symmetric Sparse matrix. Only the nonzero
*       elements of either the upper or lower triangular matrix are
*       kept and managed by Indices.
*
*=======================================================================
*
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      USE consts, ONLY : XZERO
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: N, NELM
      REAL(KIND=wp), DIMENSION(NELM) :: A
      INTEGER, DIMENSION(NELM) :: LJ1, LJ2
      REAL(KIND=wp), DIMENSION(N) :: X, Y
      INTENT (IN) A, LJ1, LJ2, N, NELM, X
      INTENT (INOUT) Y
C
C Local variables
C
      INTEGER :: IBRA, IELM, IKET
C
C*** End of declarations rewritten by SPAG
C
C
************************************************************************
*
*   on entry
*   --------
*   N           the order of the matrix A
*   X           the vector to multiply A with
*   A           Linear array keeping the the nonzero elements of
*               the matrix A.
*   LJ1         Indices of Bras of A
*   LJ2         Indices of Kets of A
*
*   on exit
*   -------
*
*   Y           the result of the multiplication (dim=N)
*
************************************************************************
C
      y=XZERO
      DO ielm=1, nelm
         ibra=lj1(ielm)
         iket=lj2(ielm)
         y(ibra)=y(ibra)+a(ielm)*x(iket)
         IF(ibra.NE.iket)y(iket)=y(iket)+a(ielm)*x(ibra)
      END DO
C
      RETURN
      END SUBROUTINE MVCORE
!*==mvdisk.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE MVDISK(N,x,y,emx,ij2,nfte,nbuf)
*=======================================================================
*
*       Computes the product of matrix A with vectors x
*                               y = A x
*       where A(NxN) is a Symmetric Sparse matrix. Only the nonzero
*       elements of either the upper or lower triangular matrix are
*       kept and managed by Indices.  A is read from disk.
*
*=======================================================================
*
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      USE consts, ONLY : XZERO

      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: N, NBUF, NFTE
      REAL(KIND=wp), DIMENSION(nbuf) :: EMX
      INTEGER, DIMENSION(2,nbuf) :: IJ2
      REAL(KIND=wp), DIMENSION(N) :: X, Y
      INTENT (IN) N, X
      INTENT (INOUT) Y
C
C Local variables
C
      INTEGER :: IBRA, IKET, L, NELM
C
C*** End of declarations rewritten by SPAG
C
C
************************************************************************
*
*   on entry
*   --------
*   N           the order of the matrix A
*   x           the vector to multiply A with
*   A           Linear array keeping the the nonzero elements of
*               the matrix A.
*   LJ1         Indices of Bras of A
*   LJ2         Indices of Kets of A
*
*   on exit
*   -------
*
*   y           the result of the multiplication (dim=N)
*
************************************************************************
C
 
      y=XZERO
 
      REWIND nfte
      READ(nfte)
      L=0
      nelm=0
 311  IF(L.EQ.NELM)THEN
         CALL REMX(nfte,NELM,IJ2,EMX,NBUF)
         IF(NELM.EQ.0)RETURN
         L=0
      END IF
      L=L+1
C
      ibra=ij2(1,l)
      iket=ij2(2,l)
      y(ibra)=y(ibra)+emx(l)*x(iket)
      IF(ibra.NE.iket)y(iket)=y(iket)+emx(l)*x(ibra)
 
      GO TO 311
C
      END SUBROUTINE MVDISK
!*==prci.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE PRCI(NOCSF,NSTATE,EE,ET,XR,CR,NCIPFG,NKEY,KEYCSF,LARGE,
     &                THRPRT,NFT)
C
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      USE consts, ONLY : ZERO=>XZERO
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      REAL(KIND=wp) :: ET, THRPRT, XR
      INTEGER :: LARGE, NCIPFG, NFT, NKEY, NOCSF, NSTATE
      REAL(KIND=wp), DIMENSION(nocsf,*) :: CR
      REAL(KIND=wp), DIMENSION(*) :: EE
      INTEGER, DIMENSION(2) :: KEYCSF
      INTENT (IN) KEYCSF, NCIPFG, NKEY, NSTATE, THRPRT
      INTENT (INOUT) LARGE
C
C Local variables
C
      REAL(KIND=wp), DIMENSION(10) :: CBIG
      REAL(KIND=wp), DIMENSION(20) :: CKEY, CKEY2, CSUMC
      REAL(KIND=wp) :: CSUMR
      INTEGER :: I, I1, INC, J, KC, NKEYN, NKF, NS, NSF, NSI
      INTEGER, DIMENSION(10) :: IBIG
      character(len=4) :: IBL='    '
      INTEGER, DIMENSION(20) :: KCSFI
C
C*** End of declarations rewritten by SPAG
C
      NKF=MIN(NKEY,20)
      LARGE=MIN(LARGE,10)
      IF(NKF.LE.0)GO TO 35
C
      I1=0
      DO I=1, NKF
         KC=KEYCSF(I) ! JMC are the array bounds really OK here for keycsf???
         DO J=1, nocsf
            IF(KC.EQ.J)GO TO 20
         END DO
         CYCLE
 20      I1=I1+1
         KCSFI(I1)=KC
      END DO
      NKF=I1
C
 35   IF(NCIPFG.NE.1)GO TO 200
      IF(NKF.LE.0)GO TO 120
C
      DO I=1, NKF
         CSUMC(I)=ZERO
      END DO
C
      NSF=0
 50   WRITE(NFT,60)NOCSF, (KCSFI(I),I=1,NKF)
 60   FORMAT('1EIGENVECTOR RECAPITULATION  NOCSF =',I6,/,9X,'ENERGY',3X,
     &       10I9/18X,10I9)
      WRITE(NFT,65)
 65   FORMAT(' ')
C
      NSI=NSF+1
      INC=20
      IF(NKF.GE.10)INC=10
      NSF=MIN(NSF+INC,NSTATE)
C
      DO I=NSI, NSF
         CSUMR=ZERO
         DO J=1, NKF
            CKEY(J)=CR(KCSFI(J),I)
            CKEY2(J)=CKEY(J)*CKEY(J)
            CSUMC(J)=CSUMC(J)+CKEY2(J)
            CSUMR=CSUMR+CKEY2(J)
         END DO
         WRITE(NFT,85)I, EE(I)+ET, (CKEY(J),J=1,NKF)
 85      FORMAT(I4,F14.6,2X,10F9.4/22X,10F9.4)
         WRITE(NFT,105)(IBL,CKEY2(J),J=1,NKF), IBL, CSUMR
 105     FORMAT(21X,10(A1,'(',F6.3,')')/21X,11(A1,'(',F6.3,')'))
         WRITE(NFT,65)
      END DO
      IF(NSF.LT.NSTATE)GO TO 50
      WRITE(NFT,115)(CSUMC(J),J=1,NKF)
 115  FORMAT(13X,'SUMS',3X,10F9.4/28X,10F9.4)
C
C     PRINT LARGE COEFFICIENTS
C
 120  IF(LARGE.LE.0)GO TO 200
      WRITE(NFT,121)
 121  FORMAT(//)
      DO NS=1, NSTATE
         DO I=1, LARGE
            CBIG(I)=ZERO
            IBIG(I)=0
         END DO
         DO I=1, LARGE
            DO J=1, nocsf
C
               IF(ABS(CR(J,NS)).LE.ABS(CBIG(I)))CYCLE
               IF(I.GT.1)THEN
                  IF(ABS(CR(J,NS)).EQ.ABS(CBIG(I-1)))THEN
                     IF(J.LE.IBIG(I-1))CYCLE
                  ELSE IF(ABS(CR(J,NS)).GT.ABS(CBIG(I-1)))THEN
                     CYCLE
                  END IF
               END IF
               IBIG(I)=j
               CBIG(I)=CR(J,NS)
            END DO
         END DO
C
         IF(NKF.GT.0)THEN
            DO I=1, NKF
               CKEY(I)=CR(KCSFI(I),NS)
            END DO
         END IF
C
         WRITE(NFT,165)NS, EE(NS)+ET, (IBIG(I),CBIG(I),I=1,LARGE)
 165     FORMAT(I4,F14.6,3X,10(I4,F7.3))
         IF(NKF.GT.0)WRITE(NFT,170)(KCSFI(J),CKEY(J),J=1,NKF)
 170     FORMAT(21X,10(I4,F7.3))
         WRITE(NFT,65)
      END DO
 200  IF(NCIPFG.EQ.2 .AND. NKF.GT.0)THEN
         NKEYN=0
         DO NS=1, NSTATE
            CSUMR=ZERO
            DO I=1, NKF
               CSUMR=CSUMR+CR(KCSFI(I),NS)*CR(KCSFI(I),NS)
            END DO
            IF(CSUMR.LT.THRPRT)CYCLE
            NKEYN=NKEYN+1
C
            CALL PRCIVC(NOCSF,NS,EE(NS),ET,XR,CR(1,NS),NFT)
C
         END DO
      END IF
C
      IF(NCIPFG.EQ.3)THEN
         DO NS=1, NSTATE
            CALL PRCIVC(NOCSF,NS,EE(NS),ET,XR,CR(1,NS),NFT)
         END DO
      END IF
C
      RETURN
      END SUBROUTINE PRCI
!*==prcivc.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE PRCIVC(NOCSF,NSTAT,EE,EN,XR,CIV,NFT)
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      REAL(KIND=wp) :: EE, EN, XR
      INTEGER :: NFT, NOCSF, NSTAT
      REAL(KIND=wp), DIMENSION(50,*) :: CIV
      INTENT (IN) CIV, EE, EN, NFT, NOCSF, NSTAT, XR
C
C Local variables
C
      REAL(KIND=wp) :: ED, ET
      INTEGER :: I, IA, IMAX, J, JA, JB, JMAX
C
C*** End of declarations rewritten by SPAG
C
      ET=EE+EN
      ED=ET-XR
      WRITE(NFT,500)NOCSF, NSTAT
      WRITE(NFT,510)EE, ET, XR, ED
C
      JMAX=(nocsf-1)/50+1
      IMAX=nocsf-50*(JMAX-1)
      JA=1
C
 200  JB=JA+7
      IF(JB.GE.JMAX)GO TO 300
      WRITE(NFT,520)((50*(j-1)+i,CIV(I,J),J=JA,JB),I=1,50)
      JA=JB+1
      WRITE(NFT,530)
      GO TO 200
C
 300  IA=1
 310  DO I=IA, IMAX
         WRITE(NFT,520)(50*(j-1)+I,CIV(I,J),J=JA,JMAX)
      END DO
      IF(IMAX.EQ.50 .OR. JA.EQ.JMAX)RETURN
      JMAX=JMAX-1
      IA=IMAX+1
      IMAX=50
      GO TO 310
C
      RETURN
C
 500  FORMAT('1 NOCSF=',I6,8X,' STATE',I5,9X,//,5X,'E (ELECTRONIC)',11X,
     &       'E (TOTAL)',7X,'E (REFERENCE)',6X,'E (DIFFERENCE)')
 510  FORMAT(/F19.8,3F20.8,/)
 520  FORMAT((1X,8(I5,F11.6)))
 530  FORMAT('1'/'0'/'0'/'0')
      END SUBROUTINE PRCIVC
!*==prtham.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE PRTHAM(HAM,NHDIM,NFT,npflg)
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: NFT, NHDIM, NPFLG
      REAL(KIND=wp), DIMENSION(nhdim,nhdim) :: HAM
      INTENT (IN) HAM, NFT, NHDIM, NPFLG
C
C Local variables
C
      INTEGER :: I, J
C
C*** End of declarations rewritten by SPAG
C
C
C***********************************************************************
C
C     PRHAM PRINTS OUT THE ELEMENTS OF THE ENERGY MATRIX
C
C           NPFLG  LE  0  DIAGONAL ELEMENTS ONLY PRINTED
C                  GT  0  ALL NON-ZERO ELEMENTS PRINTED
C
C***********************************************************************
C
C
C
      IF(NPFLG.GT.0)THEN
C
         WRITE(NFT,210)
         DO i=1, nhdim
            WRITE(NFT,220)(i,j,ham(i,j),j=1,i)
         END DO
      ELSE IF(npflg.LT.0)THEN
C
         WRITE(NFT,230)
         WRITE(NFT,220)(i,i,ham(i,i),i=1,nhdim)
      END IF
      RETURN
C
 210  FORMAT('  ELEMENTS OF ENERGY MATRIX'//)
 220  FORMAT(3(2I5,D16.8))
 230  FORMAT('  DIAGONAL ELEMENTS OF ENERGY MATRIX'//)
      END SUBROUTINE PRTHAM
!*==qldiag.spg  processed by SPAG 6.56Rc at 10:10 on  8 Nov 2010
      SUBROUTINE QLDIAG(MK,VEC,EIG)
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: MK
      REAL(KIND=wp), DIMENSION(MK) :: EIG
      REAL(KIND=wp), DIMENSION(MK,MK) :: VEC
C
C Local variables
C
      integer :: liwork,err,i,j                              ! pgg
      integer, allocatable, dimension(:) :: IWORK             ! pgg
      INTEGER :: IFAIL, LX
      REAL(KIND=wp), allocatable, DIMENSION(:) :: X   ! pgg
C
C*** End of declarations rewritten by SPAG
C
C
C*********************************************************************
C
C     QLDIAG DIAGONALIZES THE FULL HAMILTONIAN MATRIX
C
C*********************************************************************
C
C     NAG HOUSEHOLDER - QL DIAGONALIZATION  ( MUST BE IN-CORE )
C

      allocate( iwork(3+5*mk), x(1+6*mk+2*mk**2),stat=err )     !pgg
      if (err /=0) then
        print*, 'allocation error with workspace for dsyevd'
        stop
      end if


      IFAIL=0
c     lx=3*mk                      ! pgg
      lx = 1 + 6*mk + 2*mk**2      ! pgg
      liwork = 3 + 5*mk            ! pgg

       CALL dsyevd('V','L',mk,vec,mk,eig,x,lx,iwork,liwork,ifail) ! pgg
c      CALL dsyev ('V','L',mk,vec,mk,eig,x,lx,ifail)              ! pgg
C
      deallocate(iwork,x,stat=err)                   !pgg
      if (err /=0) then
        print*, 'deallocation error with workspace for dsyevd' 
        stop
      end if

      RETURN
      END SUBROUTINE QLDIAG


!*==opcore.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE OPCORE(N,M,B,C,A,LJ1,LJ2,NELM)
C=======================================================================
C
C       Computes the product of matrix A with a block of vectors B(N,M)
C                               C=A B
C       where A(NxN) is a Symmetric Sparse matrix. Only the nonzero
C       elements of either the upper or lower triangular matrix are
C       kept and managed by Indices.
C
C=======================================================================
C
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      USE consts, ONLY : XZERO
      USE maths, ONLY : MATHS_CVECA_PLUS_VECB
      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: M, N, NELM
      REAL(KIND=wp), DIMENSION(NELM) :: A
      REAL(KIND=wp), DIMENSION(N,M) :: B, C
      INTEGER, DIMENSION(NELM) :: LJ1, LJ2
      INTENT (IN) A, LJ1, LJ2, NELM
C
C Local variables
C
      REAL(KIND=wp) :: ELEM
      INTEGER :: IBRA, IELM, IKET
C
C*** End of declarations rewritten by SPAG
C
C***********************************************************************
C
C   on entry
C   --------
C   N           the order of the matrix A
C   B           the matrix (block of vectors) to multiply A with
C   A           Linear array keeping the the nonzero elements of
C               the matrix A.
C   LJ1         Indices of Bras of A
C   LJ2         Indices of Kets of A
C
C   on exit
C   -------
C
C   C           the result of the multiplication (dim=NxM)
C
C***********************************************************************
C
      c=XZERO
 
      DO ielm=1, nelm
         ibra=lj1(ielm)
         iket=lj2(ielm)
         elem=a(ielm)
         CALL MATHS_CVECA_PLUS_VECB(m,elem,b(iket,1),n,c(ibra,1),n)
         IF(ibra.NE.iket)
     &      CALL MATHS_CVECA_PLUS_VECB(m,elem,b(ibra,1),n,c(iket,1),n)
      END DO
C
      RETURN
      END SUBROUTINE OPCORE
!*==opdisk.spg  processed by SPAG 6.56Rc at 17:35 on  9 Nov 2010
      SUBROUTINE OPDISK(N,M,B,C,emx,ij2,nfte,nbuf)
C=======================================================================
C
C       Computes the product of matrix A with a block of vectors B(N,M)
C                               C=A B
C       where A(NxN) is a Symmetric Sparse matrix. Only the nonzero
C       elements of either the upper or lower triangular matrix are
C       kept and managed by Indices.  A is read from disk.
C
C=======================================================================
C
      USE precisn, ONLY : wp ! for specifying the kind of reals                        
      USE consts, ONLY : XZERO
      USE maths, ONLY : MATHS_CVECA_PLUS_VECB

      IMPLICIT NONE
C
C*** Start of declarations rewritten by SPAG
C
C Dummy arguments
C
      INTEGER :: M, N, NBUF, NFTE
      REAL(KIND=wp), DIMENSION(N,M) :: B, C
      REAL(KIND=wp), DIMENSION(nbuf) :: EMX
      INTEGER, DIMENSION(2,nbuf) :: IJ2
C
C Local variables
C
      REAL(KIND=wp) :: ELEM
      INTEGER :: IBRA, IKET, L, NELM
C
C*** End of declarations rewritten by SPAG
C
C***********************************************************************
C
C   on entry
C   --------
C   N           the order of the matrix A
C   B           the matrix (block of vectors) to multiply A with
C   A           Linear array keeping the the nonzero elements of
C               the matrix A.
C   LJ1         Indices of Bras of A
C   LJ2         Indices of Kets of A
C
C   on exit
C   -------
C
C   C           the result of the multiplication (dim=NxM)
C
C***********************************************************************
C
 
      c=XZERO
 
      REWIND nfte
      READ(nfte)
      L=0
      nelm=0
 311  IF(L.EQ.NELM)THEN
         CALL REMX(nfte,NELM,IJ2,EMX,NBUF)
         IF(NELM.EQ.0)RETURN
         L=0
      END IF
      L=L+1
C
      ibra=ij2(1,l)
      iket=ij2(2,l)
      elem=emx(l)
      CALL MATHS_CVECA_PLUS_VECB(m,elem,b(iket,1),n,c(ibra,1),n)
      IF(ibra.NE.iket)
     &   CALL MATHS_CVECA_PLUS_VECB(m,elem,b(ibra,1),n,c(iket,1),n)
 
      GO TO 311
C
      END SUBROUTINE OPDISK
